diff --git a/compiler/rename/RnBinds.lhs b/compiler/rename/RnBinds.lhs
index 9f9fd38..18d7625 100644
--- a/compiler/rename/RnBinds.lhs
+++ b/compiler/rename/RnBinds.lhs
@@ -9,12 +9,6 @@ type-synonym declarations; those cannot be done at this stage because
 they may be affected by renaming (which isn't fully worked out yet).
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module RnBinds (
    -- Renaming top-level bindings
@@ -45,14 +39,14 @@ import NameEnv
 import NameSet
 import RdrName          ( RdrName, rdrNameOcc )
 import SrcLoc
-import ListSetOps	( findDupsEq )
-import BasicTypes	( RecFlag(..) )
-import Digraph		( SCC(..) )
+import ListSetOps       ( findDupsEq )
+import BasicTypes       ( RecFlag(..) )
+import Digraph          ( SCC(..) )
 import Bag
 import Outputable
 import FastString
-import Data.List	( partition, sort )
-import Maybes		( orElse )
+import Data.List        ( partition, sort )
+import Maybes           ( orElse )
 import Control.Monad
 import Data.Traversable ( traverse )
 \end{code}
@@ -65,7 +59,7 @@ in where-clauses which are all apparently mutually recursive, but which may
 not really depend upon each other. For example, in the top level program
 \begin{verbatim}
 f x = y where a = x
-	      y = x
+              y = x
 \end{verbatim}
 the definitions of @a@ and @y@ do not depend on each other at all.
 Unfortunately, the typechecker cannot always check such definitions.
@@ -85,9 +79,9 @@ within one @MonoBinds@, so that unique-Int plumbing is done explicitly
 
 
 %************************************************************************
-%*									*
-%* naming conventions							*
-%*									*
+%*                                                                      *
+%* naming conventions                                                   *
+%*                                                                      *
 %************************************************************************
 
 \subsection[name-conventions]{Name conventions}
@@ -112,9 +106,9 @@ a set of variables free in @Exp@ is written @fvExp@
 \end{itemize}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 %* analysing polymorphic bindings (HsBindGroup, HsBind)
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \subsubsection[dep-HsBinds]{Polymorphic bindings}
@@ -153,14 +147,14 @@ union of those in the previous set plus those of the newest binding after
 the defined variables of the previous set have been removed.
 
 @rnMethodBinds@ deals only with the declarations in class and
-instance declarations.	It expects only to see @FunMonoBind@s, and
+instance declarations.  It expects only to see @FunMonoBind@s, and
 it expects the global environment to contain bindings for the binders
 (which are all class operations).
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsubsection{ Top-level bindings}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -184,17 +178,17 @@ rnTopBindsBoot :: HsValBindsLR Name RdrName -> RnM (HsValBinds Name, DefUses)
 -- A hs-boot file has no bindings. 
 -- Return a single HsBindGroup with empty binds and renamed signatures
 rnTopBindsBoot (ValBindsIn mbinds sigs)
-  = do	{ checkErr (isEmptyLHsBinds mbinds) (bindsInHsBootFile mbinds)
-	; (sigs', fvs) <- renameSigs HsBootCtxt sigs
-	; return (ValBindsOut [] sigs', usesOnly fvs) }
+  = do  { checkErr (isEmptyLHsBinds mbinds) (bindsInHsBootFile mbinds)
+        ; (sigs', fvs) <- renameSigs HsBootCtxt sigs
+        ; return (ValBindsOut [] sigs', usesOnly fvs) }
 rnTopBindsBoot b = pprPanic "rnTopBindsBoot" (ppr b)
 \end{code}
 
 
 %*********************************************************
-%*							*
-		HsLocalBinds
-%*							*
+%*                                                      *
+                HsLocalBinds
+%*                                                      *
 %*********************************************************
 
 \begin{code}
@@ -202,7 +196,7 @@ rnLocalBindsAndThen :: HsLocalBinds RdrName
                     -> (HsLocalBinds Name -> RnM (result, FreeVars))
                     -> RnM (result, FreeVars)
 -- This version (a) assumes that the binding vars are *not* already in scope
---		 (b) removes the binders from the free vars of the thing inside
+--               (b) removes the binders from the free vars of the thing inside
 -- The parser doesn't produce ThenBinds
 rnLocalBindsAndThen EmptyLocalBinds thing_inside
   = thing_inside EmptyLocalBinds
@@ -229,9 +223,9 @@ rnIPBind (IPBind ~(Left n) expr) = do
 
 
 %************************************************************************
-%*									*
-		ValBinds
-%*									*
+%*                                                                      *
+                ValBinds
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -244,23 +238,23 @@ rnLocalValBindsLHS fix_env binds
   = do { binds' <- rnValBindsLHS (localRecNameMaker fix_env) binds 
 
          -- Check for duplicates and shadowing
-	 -- Must do this *after* renaming the patterns
-	 -- See Note [Collect binders only after renaming] in HsUtils
+         -- Must do this *after* renaming the patterns
+         -- See Note [Collect binders only after renaming] in HsUtils
 
          -- We need to check for dups here because we
-     	 -- don't don't bind all of the variables from the ValBinds at once
-     	 -- with bindLocatedLocals any more.
+         -- don't don't bind all of the variables from the ValBinds at once
+         -- with bindLocatedLocals any more.
          -- 
-     	 -- Note that we don't want to do this at the top level, since
-     	 -- sorting out duplicates and shadowing there happens elsewhere.
-     	 -- The behavior is even different. For example,
-     	 --   import A(f)
-     	 --   f = ...
-     	 -- should not produce a shadowing warning (but it will produce
-     	 -- an ambiguity warning if you use f), but
-     	 --   import A(f)
-     	 --   g = let f = ... in f
-     	 -- should.
+         -- Note that we don't want to do this at the top level, since
+         -- sorting out duplicates and shadowing there happens elsewhere.
+         -- The behavior is even different. For example,
+         --   import A(f)
+         --   f = ...
+         -- should not produce a shadowing warning (but it will produce
+         -- an ambiguity warning if you use f), but
+         --   import A(f)
+         --   g = let f = ... in f
+         -- should.
        ; let bound_names = collectHsValBinders binds'
        ; envs <- getRdrEnvs
        ; checkDupAndShadowedNames envs bound_names
@@ -298,9 +292,9 @@ rnValBindsRHS ctxt (ValBindsIn mbinds sigs)
               where
                 valbind' = ValBindsOut anal_binds sigs'
                 valbind'_dus = anal_dus `plusDU` usesOnly sig_fvs
-			       -- Put the sig uses *after* the bindings
-			       -- so that the binders are removed from 
-			       -- the uses in the sigs
+                               -- Put the sig uses *after* the bindings
+                               -- so that the binders are removed from 
+                               -- the uses in the sigs
        }
 
 rnValBindsRHS _ b = pprPanic "rnValBindsRHS" (ppr b)
@@ -326,51 +320,51 @@ rnLocalValBindsAndThen :: HsValBinds RdrName
                        -> (HsValBinds Name -> RnM (result, FreeVars))
                        -> RnM (result, FreeVars)
 rnLocalValBindsAndThen binds@(ValBindsIn _ sigs) thing_inside
- = do	{     -- (A) Create the local fixity environment 
-	  new_fixities <- makeMiniFixityEnv [L loc sig | L loc (FixSig sig) <- sigs]
+ = do   {     -- (A) Create the local fixity environment 
+          new_fixities <- makeMiniFixityEnv [L loc sig | L loc (FixSig sig) <- sigs]
 
-	      -- (B) Rename the LHSes 
-	; (bound_names, new_lhs) <- rnLocalValBindsLHS new_fixities binds
+              -- (B) Rename the LHSes 
+        ; (bound_names, new_lhs) <- rnLocalValBindsLHS new_fixities binds
 
-	      --     ...and bring them (and their fixities) into scope
-	; bindLocalNamesFV bound_names              $
+              --     ...and bring them (and their fixities) into scope
+        ; bindLocalNamesFV bound_names              $
           addLocalFixities new_fixities bound_names $ do
 
-	{      -- (C) Do the RHS and thing inside
-	  (binds', dus) <- rnLocalValBindsRHS (mkNameSet bound_names) new_lhs 
+        {      -- (C) Do the RHS and thing inside
+          (binds', dus) <- rnLocalValBindsRHS (mkNameSet bound_names) new_lhs 
         ; (result, result_fvs) <- thing_inside binds'
 
-		-- Report unused bindings based on the (accurate) 
-		-- findUses.  E.g.
-		-- 	let x = x in 3
-		-- should report 'x' unused
-	; let real_uses = findUses dus result_fvs
-	      -- Insert fake uses for variables introduced implicitly by wildcards (#4404)
-	      implicit_uses = hsValBindsImplicits binds'
-	; warnUnusedLocalBinds bound_names (real_uses `unionNameSets` implicit_uses)
+                -- Report unused bindings based on the (accurate) 
+                -- findUses.  E.g.
+                --      let x = x in 3
+                -- should report 'x' unused
+        ; let real_uses = findUses dus result_fvs
+              -- Insert fake uses for variables introduced implicitly by wildcards (#4404)
+              implicit_uses = hsValBindsImplicits binds'
+        ; warnUnusedLocalBinds bound_names (real_uses `unionNameSets` implicit_uses)
 
-	; let
+        ; let
             -- The variables "used" in the val binds are: 
             --   (1) the uses of the binds (allUses)
             --   (2) the FVs of the thing-inside
             all_uses = allUses dus `plusFV` result_fvs
-		-- Note [Unused binding hack]
-		-- ~~~~~~~~~~~~~~~~~~~~~~~~~~
-		-- Note that *in contrast* to the above reporting of
-		-- unused bindings, (1) above uses duUses to return *all* 
-		-- the uses, even if the binding is unused.  Otherwise consider:
-                --	x = 3
-                --	y = let p = x in 'x'	-- NB: p not used
+                -- Note [Unused binding hack]
+                -- ~~~~~~~~~~~~~~~~~~~~~~~~~~
+                -- Note that *in contrast* to the above reporting of
+                -- unused bindings, (1) above uses duUses to return *all* 
+                -- the uses, even if the binding is unused.  Otherwise consider:
+                --      x = 3
+                --      y = let p = x in 'x'    -- NB: p not used
                 -- If we don't "see" the dependency of 'y' on 'x', we may put the
                 -- bindings in the wrong order, and the type checker will complain
                 -- that x isn't in scope
-		--
-		-- But note that this means we won't report 'x' as unused, 
-		-- whereas we would if we had { x = 3; p = x; y = 'x' }
+                --
+                -- But note that this means we won't report 'x' as unused, 
+                -- whereas we would if we had { x = 3; p = x; y = 'x' }
 
-	; return (result, all_uses) }}
-         	-- The bound names are pruned out of all_uses
-	        -- by the bindLocalNamesFV call above
+        ; return (result, all_uses) }}
+                -- The bound names are pruned out of all_uses
+                -- by the bindLocalNamesFV call above
 
 rnLocalValBindsAndThen bs _ = pprPanic "rnLocalValBindsAndThen" (ppr bs)
 
@@ -405,7 +399,7 @@ makeMiniFixityEnv decls = foldlM add_one emptyFsEnv decls
 dupFixityDecl :: SrcSpan -> RdrName -> SDoc
 dupFixityDecl loc rdr_name
   = vcat [ptext (sLit "Multiple fixity declarations for") <+> quotes (ppr rdr_name),
-	  ptext (sLit "also at ") <+> ppr loc]
+          ptext (sLit "also at ") <+> ppr loc]
 
 ---------------------
 
@@ -436,7 +430,7 @@ rnBindLHS name_maker _ (L loc bind@(FunBind { fun_id = name@(L nameLoc _) }))
 rnBindLHS _ _ b = pprPanic "rnBindLHS" (ppr b)
 
 -- assumes the left-hands-side vars are in scope
-rnBind :: (Name -> [Name])		-- Signature tyvar function
+rnBind :: (Name -> [Name])              -- Signature tyvar function
        -> LHsBindLR Name RdrName
        -> RnM (LHsBind Name, [Name], Uses)
 rnBind _ (L loc bind@(PatBind { pat_lhs = pat
@@ -445,15 +439,15 @@ rnBind _ (L loc bind@(PatBind { pat_lhs = pat
                                       -- after processing the LHS
                               , bind_fvs = pat_fvs }))
   = setSrcSpan loc $ 
-    do	{ mod <- getModule
+    do  { mod <- getModule
         ; (grhss', rhs_fvs) <- rnGRHSs PatBindRhs rnLExpr grhss
 
-		-- No scoped type variables for pattern bindings
-	; let all_fvs = pat_fvs `plusFV` rhs_fvs
+                -- No scoped type variables for pattern bindings
+        ; let all_fvs = pat_fvs `plusFV` rhs_fvs
               fvs'    = filterNameSet (nameIsLocalOrFrom mod) all_fvs
-	        -- Keep locally-defined Names
-		-- As well as dependency analysis, we need these for the
-		-- MonoLocalBinds test in TcBinds.decideGeneralisationPlan
+                -- Keep locally-defined Names
+                -- As well as dependency analysis, we need these for the
+                -- MonoLocalBinds test in TcBinds.decideGeneralisationPlan
               bndrs = collectPatBinders pat
               bind' = bind { pat_rhs  = grhss', bind_fvs = fvs' }
               is_wild_pat = case pat of
@@ -469,31 +463,31 @@ rnBind _ (L loc bind@(PatBind { pat_lhs = pat
           when (null bndrs && not is_wild_pat) $
           addWarn $ unusedPatBindWarn bind'
 
-	; fvs' `seq` -- See Note [Free-variable space leak]
+        ; fvs' `seq` -- See Note [Free-variable space leak]
           return (L loc bind', bndrs, all_fvs) }
 
 rnBind sig_fn (L loc bind@(FunBind { fun_id = name 
-                            	   , fun_infix = is_infix 
-                            	   , fun_matches = matches })) 
+                                   , fun_infix = is_infix 
+                                   , fun_matches = matches })) 
        -- invariant: no free vars here when it's a FunBind
   = setSrcSpan loc $
-    do	{ let plain_name = unLoc name
+    do  { let plain_name = unLoc name
 
-	; (matches', rhs_fvs) <- bindSigTyVarsFV (sig_fn plain_name) $
-				-- bindSigTyVars tests for Opt_ScopedTyVars
-			         rnMatchGroup (FunRhs plain_name is_infix) rnLExpr matches
-	; when is_infix $ checkPrecMatch plain_name matches'
+        ; (matches', rhs_fvs) <- bindSigTyVarsFV (sig_fn plain_name) $
+                                -- bindSigTyVars tests for Opt_ScopedTyVars
+                                 rnMatchGroup (FunRhs plain_name is_infix) rnLExpr matches
+        ; when is_infix $ checkPrecMatch plain_name matches'
 
         ; mod <- getModule
         ; let fvs' = filterNameSet (nameIsLocalOrFrom mod) rhs_fvs
-	        -- Keep locally-defined Names
-		-- As well as dependency analysis, we need these for the
-		-- MonoLocalBinds test in TcBinds.decideGeneralisationPlan
+                -- Keep locally-defined Names
+                -- As well as dependency analysis, we need these for the
+                -- MonoLocalBinds test in TcBinds.decideGeneralisationPlan
 
-	; fvs' `seq` -- See Note [Free-variable space leak]
+        ; fvs' `seq` -- See Note [Free-variable space leak]
           return (L loc (bind { fun_matches = matches'
-			      , bind_fvs   = fvs' }), 
-		  [plain_name], rhs_fvs)
+                              , bind_fvs   = fvs' }), 
+                  [plain_name], rhs_fvs)
       }
 
 rnBind _ b = pprPanic "rnBind" (ppr b)
@@ -513,7 +507,7 @@ trac ticket #1136.
 
 ---------------------
 depAnalBinds :: Bag (LHsBind Name, [Name], Uses)
-	     -> ([(RecFlag, LHsBinds Name)], DefUses)
+             -> ([(RecFlag, LHsBinds Name)], DefUses)
 -- Dependency analysis; this is important so that 
 -- unused-binding reporting is accurate
 depAnalBinds binds_w_dus
@@ -528,21 +522,21 @@ depAnalBinds binds_w_dus
 
     get_du (AcyclicSCC (_, bndrs, uses)) = (Just (mkNameSet bndrs), uses)
     get_du (CyclicSCC  binds_w_dus)      = (Just defs, uses)
-	where
-	  defs = mkNameSet [b | (_,bs,_) <- binds_w_dus, b <- bs]
-	  uses = unionManyNameSets [u | (_,_,u) <- binds_w_dus]
+        where
+          defs = mkNameSet [b | (_,bs,_) <- binds_w_dus, b <- bs]
+          uses = unionManyNameSets [u | (_,_,u) <- binds_w_dus]
 
 ---------------------
 -- Bind the top-level forall'd type variables in the sigs.
--- E.g 	f :: a -> a
---	f = rhs
---	The 'a' scopes over the rhs
+-- E.g  f :: a -> a
+--      f = rhs
+--      The 'a' scopes over the rhs
 --
 -- NB: there'll usually be just one (for a function binding)
 --     but if there are many, one may shadow the rest; too bad!
---	e.g  x :: [a] -> [a]
---	     y :: [(a,a)] -> a
---	     (x,y) = e
+--      e.g  x :: [a] -> [a]
+--           y :: [(a,a)] -> a
+--           (x,y) = e
 --      In e, 'a' will be in scope, and it'll be the one from 'y'!
 
 mkSigTvFn :: [LSig Name] -> (Name -> [Name])
@@ -553,11 +547,11 @@ mkSigTvFn sigs
   where
     env :: NameEnv [Name]
     env = mkNameEnv [ (name, hsLKiTyVarNames ltvs)  -- Kind variables and type variables
-		    | L _ (TypeSig names
-			           (L _ (HsForAllTy Explicit ltvs _ _))) <- sigs
+                    | L _ (TypeSig names
+                                   (L _ (HsForAllTy Explicit ltvs _ _))) <- sigs
                     , (L _ name) <- names]
-	-- Note the pattern-match on "Explicit"; we only bind
-	-- type variables from signatures with an explicit top-level for-all
+        -- Note the pattern-match on "Explicit"; we only bind
+        -- type variables from signatures with an explicit top-level for-all
 \end{code}
 
 
@@ -567,8 +561,8 @@ declaration.   Like @rnBinds@ but without dependency analysis.
 NOTA BENE: we record each {\em binder} of a method-bind group as a free variable.
 That's crucial when dealing with an instance decl:
 \begin{verbatim}
-	instance Foo (T a) where
-	   op x = ...
+        instance Foo (T a) where
+           op x = ...
 \end{verbatim}
 This might be the {\em sole} occurrence of @op@ for an imported class @Foo@,
 and unless @op@ occurs we won't treat the type signature of @op@ in the class
@@ -577,37 +571,37 @@ in many ways the @op@ in an instance decl is just like an occurrence, not
 a binder.
 
 \begin{code}
-rnMethodBinds :: Name			-- Class name
-	      -> (Name -> [Name])	-- Signature tyvar function
-	      -> LHsBinds RdrName
-	      -> RnM (LHsBinds Name, FreeVars)
+rnMethodBinds :: Name                   -- Class name
+              -> (Name -> [Name])       -- Signature tyvar function
+              -> LHsBinds RdrName
+              -> RnM (LHsBinds Name, FreeVars)
 
 rnMethodBinds cls sig_fn binds
   = do { checkDupRdrNames meth_names
-	     -- Check that the same method is not given twice in the
-	     -- same instance decl	instance C T where
-	     --			      f x = ...
-	     --			      g y = ...
-	     --			      f x = ...
-	     -- We must use checkDupRdrNames because the Name of the
-	     -- method is the Name of the class selector, whose SrcSpan
-	     -- points to the class declaration; and we use rnMethodBinds
-	     -- for instance decls too
+             -- Check that the same method is not given twice in the
+             -- same instance decl      instance C T where
+             --                       f x = ...
+             --                       g y = ...
+             --                       f x = ...
+             -- We must use checkDupRdrNames because the Name of the
+             -- method is the Name of the class selector, whose SrcSpan
+             -- points to the class declaration; and we use rnMethodBinds
+             -- for instance decls too
 
        ; foldlM do_one (emptyBag, emptyFVs) (bagToList binds) }
   where 
     meth_names  = collectMethodBinders binds
     do_one (binds,fvs) bind 
        = do { (bind', fvs_bind) <- rnMethodBind cls sig_fn bind
-	    ; return (binds `unionBags` bind', fvs_bind `plusFV` fvs) }
+            ; return (binds `unionBags` bind', fvs_bind `plusFV` fvs) }
 
 rnMethodBind :: Name
-	      -> (Name -> [Name])
-	      -> LHsBindLR RdrName RdrName
-	      -> RnM (Bag (LHsBindLR Name Name), FreeVars)
+              -> (Name -> [Name])
+              -> LHsBindLR RdrName RdrName
+              -> RnM (Bag (LHsBindLR Name Name), FreeVars)
 rnMethodBind cls sig_fn 
              (L loc bind@(FunBind { fun_id = name, fun_infix = is_infix 
-				  , fun_matches = MG { mg_alts = matches } }))
+                                  , fun_matches = MG { mg_alts = matches } }))
   = setSrcSpan loc $ do
     sel_name <- wrapLocM (lookupInstDeclBndr cls (ptext (sLit "method"))) name
     let plain_name = unLoc sel_name
@@ -635,9 +629,9 @@ rnMethodBind _ _ b = pprPanic "rnMethodBind" (ppr b)
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsubsection[dep-Sigs]{Signatures (and user-pragmas for values)}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 @renameSigs@ checks for:
@@ -651,27 +645,27 @@ signatures.  We'd only need this if we wanted to report unused tyvars.
 
 \begin{code}
 renameSigs :: HsSigCtxt 
-	   -> [LSig RdrName]
-	   -> RnM ([LSig Name], FreeVars)
+           -> [LSig RdrName]
+           -> RnM ([LSig Name], FreeVars)
 -- Renames the signatures and performs error checks
 renameSigs ctxt sigs 
-  = do	{ mapM_ dupSigDeclErr (findDupSigs sigs)
+  = do  { mapM_ dupSigDeclErr (findDupSigs sigs)
 
-	; checkDupMinimalSigs sigs
+        ; checkDupMinimalSigs sigs
 
-	; (sigs', sig_fvs) <- mapFvRn (wrapLocFstM (renameSig ctxt)) sigs
+        ; (sigs', sig_fvs) <- mapFvRn (wrapLocFstM (renameSig ctxt)) sigs
 
-	; let (good_sigs, bad_sigs) = partition (okHsSig ctxt) sigs'
-	; mapM_ misplacedSigErr bad_sigs		 -- Misplaced
+        ; let (good_sigs, bad_sigs) = partition (okHsSig ctxt) sigs'
+        ; mapM_ misplacedSigErr bad_sigs                 -- Misplaced
 
-	; return (good_sigs, sig_fvs) } 
+        ; return (good_sigs, sig_fvs) } 
 
 ----------------------
 -- We use lookupSigOccRn in the signatures, which is a little bit unsatisfactory
 -- because this won't work for:
---	instance Foo T where
---	  {-# INLINE op #-}
---	  Baz.op = ...
+--      instance Foo T where
+--        {-# INLINE op #-}
+--        Baz.op = ...
 -- We'll just rename the INLINE prag to refer to whatever other 'op'
 -- is in scope.  (I'm assuming that Baz.op isn't in scope unqualified.)
 -- Doesn't seem worth much trouble to sort this.
@@ -679,42 +673,42 @@ renameSigs ctxt sigs
 renameSig :: HsSigCtxt -> Sig RdrName -> RnM (Sig Name, FreeVars)
 -- FixitySig is renamed elsewhere.
 renameSig _ (IdSig x)
-  = return (IdSig x, emptyFVs)	  -- Actually this never occurs
+  = return (IdSig x, emptyFVs)    -- Actually this never occurs
 
 renameSig ctxt sig@(TypeSig vs ty)
-  = do	{ new_vs <- mapM (lookupSigOccRn ctxt sig) vs
-	; (new_ty, fvs) <- rnHsSigType (ppr_sig_bndrs vs) ty
-	; return (TypeSig new_vs new_ty, fvs) }
+  = do  { new_vs <- mapM (lookupSigOccRn ctxt sig) vs
+        ; (new_ty, fvs) <- rnHsSigType (ppr_sig_bndrs vs) ty
+        ; return (TypeSig new_vs new_ty, fvs) }
 
 renameSig ctxt sig@(GenericSig vs ty)
-  = do	{ defaultSigs_on <- xoptM Opt_DefaultSignatures
+  = do  { defaultSigs_on <- xoptM Opt_DefaultSignatures
         ; unless defaultSigs_on (addErr (defaultSigErr sig))
         ; new_v <- mapM (lookupSigOccRn ctxt sig) vs
-	; (new_ty, fvs) <- rnHsSigType (ppr_sig_bndrs vs) ty
-	; return (GenericSig new_v new_ty, fvs) }
+        ; (new_ty, fvs) <- rnHsSigType (ppr_sig_bndrs vs) ty
+        ; return (GenericSig new_v new_ty, fvs) }
 
 renameSig _ (SpecInstSig ty)
-  = do	{ (new_ty, fvs) <- rnLHsType SpecInstSigCtx ty
-	; return (SpecInstSig new_ty,fvs) }
+  = do  { (new_ty, fvs) <- rnLHsType SpecInstSigCtx ty
+        ; return (SpecInstSig new_ty,fvs) }
 
 -- {-# SPECIALISE #-} pragmas can refer to imported Ids
 -- so, in the top-level case (when mb_names is Nothing)
 -- we use lookupOccRn.  If there's both an imported and a local 'f'
 -- then the SPECIALISE pragma is ambiguous, unlike all other signatures
 renameSig ctxt sig@(SpecSig v ty inl)
-  = do	{ new_v <- case ctxt of 
+  = do  { new_v <- case ctxt of 
                      TopSigCtxt {} -> lookupLocatedOccRn v
                      _             -> lookupSigOccRn ctxt sig v
-	; (new_ty, fvs) <- rnHsSigType (quotes (ppr v)) ty
-	; return (SpecSig new_v new_ty inl, fvs) }
+        ; (new_ty, fvs) <- rnHsSigType (quotes (ppr v)) ty
+        ; return (SpecSig new_v new_ty inl, fvs) }
 
 renameSig ctxt sig@(InlineSig v s)
-  = do	{ new_v <- lookupSigOccRn ctxt sig v
-	; return (InlineSig new_v s, emptyFVs) }
+  = do  { new_v <- lookupSigOccRn ctxt sig v
+        ; return (InlineSig new_v s, emptyFVs) }
 
 renameSig ctxt sig@(FixSig (FixitySig v f))
-  = do	{ new_v <- lookupSigOccRn ctxt sig v
-	; return (FixSig (FixitySig new_v f), emptyFVs) }
+  = do  { new_v <- lookupSigOccRn ctxt sig v
+        ; return (FixSig (FixitySig new_v f), emptyFVs) }
 
 renameSig ctxt sig@(MinimalSig bf)
   = do new_bf <- traverse (lookupSigOccRn ctxt sig) bf
@@ -759,8 +753,8 @@ findDupSigs :: [LSig RdrName] -> [[(Located RdrName, Sig RdrName)]]
 -- not-in-scope binders, which gives bogus dup-sig errors
 -- NB: in a class decl, a 'generic' sig is not considered 
 --     equal to an ordinary sig, so we allow, say
---     	     class C a where
---	       op :: a -> a
+--           class C a where
+--             op :: a -> a
 --             default op :: Eq a => a -> a
 findDupSigs sigs
   = findDupsEq matching_sig (concatMap (expand_sig . unLoc) sigs)
@@ -788,9 +782,9 @@ checkDupMinimalSigs sigs
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Match}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -815,17 +809,17 @@ rnMatch' :: Outputable (body RdrName) => HsMatchContext Name
          -> Match RdrName (Located (body RdrName))
          -> RnM (Match Name (Located (body Name)), FreeVars)
 rnMatch' ctxt rnBody match@(Match pats maybe_rhs_sig grhss)
-  = do 	{ 	-- Result type signatures are no longer supported
-	  case maybe_rhs_sig of	
-	        Nothing -> return ()
-	        Just (L loc ty) -> addErrAt loc (resSigErr ctxt match ty)
+  = do  {       -- Result type signatures are no longer supported
+          case maybe_rhs_sig of 
+                Nothing -> return ()
+                Just (L loc ty) -> addErrAt loc (resSigErr ctxt match ty)
 
-	       -- Now the main event
-	       -- note that there are no local ficity decls for matches
-	; rnPats ctxt pats	$ \ pats' -> do
-	{ (grhss', grhss_fvs) <- rnGRHSs ctxt rnBody grhss
+               -- Now the main event
+               -- note that there are no local ficity decls for matches
+        ; rnPats ctxt pats      $ \ pats' -> do
+        { (grhss', grhss_fvs) <- rnGRHSs ctxt rnBody grhss
 
-	; return (Match pats' Nothing grhss', grhss_fvs) }}
+        ; return (Match pats' Nothing grhss', grhss_fvs) }}
 
 emptyCaseErr :: HsMatchContext Name -> SDoc
 emptyCaseErr ctxt = hang (ptext (sLit "Empty list of alternatives in") <+> pp_ctxt)
@@ -840,15 +834,15 @@ emptyCaseErr ctxt = hang (ptext (sLit "Empty list of alternatives in") <+> pp_ct
 resSigErr :: Outputable body => HsMatchContext Name -> Match RdrName body -> HsType RdrName -> SDoc 
 resSigErr ctxt match ty
    = vcat [ ptext (sLit "Illegal result type signature") <+> quotes (ppr ty)
-	  , nest 2 $ ptext (sLit "Result signatures are no longer supported in pattern matches")
- 	  , pprMatchInCtxt ctxt match ]
+          , nest 2 $ ptext (sLit "Result signatures are no longer supported in pattern matches")
+          , pprMatchInCtxt ctxt match ]
 \end{code}
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsubsection{Guarded right-hand sides (GRHSs)}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -857,7 +851,7 @@ rnGRHSs :: HsMatchContext Name
         -> GRHSs RdrName (Located (body RdrName))
         -> RnM (GRHSs Name (Located (body Name)), FreeVars)
 rnGRHSs ctxt rnBody (GRHSs grhss binds)
-  = rnLocalBindsAndThen binds	$ \ binds' -> do
+  = rnLocalBindsAndThen binds   $ \ binds' -> do
     (grhss', fvGRHSs) <- mapFvRn (rnGRHS ctxt rnBody) grhss
     return (GRHSs grhss' binds', fvGRHSs)
 
@@ -872,27 +866,27 @@ rnGRHS' :: HsMatchContext Name
         -> GRHS RdrName (Located (body RdrName))
         -> RnM (GRHS Name (Located (body Name)), FreeVars)
 rnGRHS' ctxt rnBody (GRHS guards rhs)
-  = do	{ pattern_guards_allowed <- xoptM Opt_PatternGuards
+  = do  { pattern_guards_allowed <- xoptM Opt_PatternGuards
         ; ((guards', rhs'), fvs) <- rnStmts (PatGuard ctxt) rnLExpr guards $ \ _ ->
-				    rnBody rhs
+                                    rnBody rhs
 
-	; unless (pattern_guards_allowed || is_standard_guard guards')
-	  	 (addWarn (nonStdGuardErr guards'))
+        ; unless (pattern_guards_allowed || is_standard_guard guards')
+                 (addWarn (nonStdGuardErr guards'))
 
-	; return (GRHS guards' rhs', fvs) }
+        ; return (GRHS guards' rhs', fvs) }
   where
-	-- Standard Haskell 1.4 guards are just a single boolean
-	-- expression, rather than a list of qualifiers as in the
-	-- Glasgow extension
+        -- Standard Haskell 1.4 guards are just a single boolean
+        -- expression, rather than a list of qualifiers as in the
+        -- Glasgow extension
     is_standard_guard []                       = True
     is_standard_guard [L _ (BodyStmt _ _ _ _)] = True
     is_standard_guard _                        = False
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Error messages}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
